function fW = fisher(data)
%   reduced data = (fW*orig_data')';
%   the 's will get it in the same form as the orig_data 
%   and preserve the class labels

N = size(data,1);
D = size(data,2);
c1 = 1:N/5;
c2 = 1+N/5:2*N/5;
c3 = 1+2*N/5:3*N/5;
c4 = 1+3*N/5:4*N/5;
c5 = 1+4*N/5:N;

fW = zeros(5,D);

mu = mean(data(:,2:D));
Sw = (data(:,2:D) - ones(N,1)*mu)'*(data(:,2:D) - ones(N,1)*mu);
mu1 = mean(data(c1,2:D));
mu2 = mean(data(c2,2:D));
mu3 = mean(data(c3,2:D));
mu4 = mean(data(c4,2:D));
mu5 = mean(data(c5,2:D));
Sb = (N/5)*((mu1-mu)'*(mu1-mu) + (mu2-mu)'*(mu2-mu) + (mu3-mu)'*(mu3-mu) + (mu4-mu)'*(mu4-mu) + (mu5-mu)'*(mu5-mu));
[fv fd] = eig(Sb,Sw);
[cc i1] = max(max(fd));
fd(i1,:) = 0;
[cc i2] = max(max(fd));
fd(i2,:) = 0;
[cc i3] = max(max(fd));
fd(i3,:) = 0;
[cc i4] = max(max(fd));
fi = [i1,i2,i3,i4];
fW(2:5,2:D) = fv(:,fi)';
fW(1,1) = 1;
