function data_out = reduce(data,type);
% type 
%     1 = accel_cal
%       class label, 48 buttons, 3 accel w/ 0 = 0g
%     2 = accel_only
%       class label, 3 accel w/ 0 = 0g
%     3 = but_group
%       class label, 6 button groups, 3 accel w/ 0 = 0g
%     4 = but_only
%       class label, 6 button groups
%     5 = rat_group
%       class label, 6 'mirrored' but groups, 3 'mirrored' (X,Y > 0) accel
%           w/ 0 = 0g
%     6 = rat_scale

    
N = size(data,1);
c1 = 1:N/5;
c2 = 1+N/5:2*N/5;
c3 = 1+2*N/5:3*N/5;
c4 = 1+3*N/5:4*N/5;
c5 = 1+4*N/5:N;

b1 = zeros(N,12);
b2 = zeros(N,12);
s1 = zeros(N,7);
s2 = zeros(N,7);
s3 = zeros(N,5);
s4 = zeros(N,5);

b1(:,1:4) = data(:,6:9);
b1(:,5:8) = data(:,14:17);
b1(:,9:12) = data(:,22:25);
b2(:,1:4) = data(:,2:5);
b2(:,5:8) = data(:,10:13);
b2(:,9:12) = data(:,18:21);
s1(:,1:7) = data(:,26:32);
s2(:,1:4) = data(:,34:37);
s2(:,5:7) = data(:,42:44);
s3(:,1:4) = data(:,38:41);
s3(:,5) = data(:,33);
s4(:,1:5) = data(:,45:49);
bd_cnt = sum(b1,2);
bu_cnt = sum(b2,2);
sr_cnt = sum(s1,2);
sl_cnt = sum(s2,2);
su_cnt = sum(s3,2);
sd_cnt = sum(s4,2);

% diagnostics for buttons
% avg_but_cnt = zeros(5,6);
% avg_but_cnt(1,:) = [mean(bd_cnt(c1)),mean(bu_cnt(c1)),mean(sr_cnt(c1)),mean(sl_cnt(c1)),mean(su_cnt(c1)),mean(sd_cnt(c1))];
% avg_but_cnt(2,:) = [mean(bd_cnt(c2)),mean(bu_cnt(c2)),mean(sr_cnt(c2)),mean(sl_cnt(c2)),mean(su_cnt(c2)),mean(sd_cnt(c2))];
% avg_but_cnt(3,:) = [mean(bd_cnt(c3)),mean(bu_cnt(c3)),mean(sr_cnt(c3)),mean(sl_cnt(c3)),mean(su_cnt(c3)),mean(sd_cnt(c3))];
% avg_but_cnt(4,:) = [mean(bd_cnt(c4)),mean(bu_cnt(c4)),mean(sr_cnt(c4)),mean(sl_cnt(c4)),mean(su_cnt(c4)),mean(sd_cnt(c4))];
% avg_but_cnt(5,:) = [mean(bd_cnt(c5)),mean(bu_cnt(c5)),mean(sr_cnt(c5)),mean(sl_cnt(c5)),mean(su_cnt(c5)),mean(sd_cnt(c5))];
% var_but_cnt = zeros(5,6);
% var_but_cnt(1,:) = [var(bd_cnt(c1)),var(bu_cnt(c1)),var(sr_cnt(c1)),var(sl_cnt(c1)),var(su_cnt(c1)),var(sd_cnt(c1))];
% var_but_cnt(2,:) = [var(bd_cnt(c2)),var(bu_cnt(c2)),var(sr_cnt(c2)),var(sl_cnt(c2)),var(su_cnt(c2)),var(sd_cnt(c2))];
% var_but_cnt(3,:) = [var(bd_cnt(c3)),var(bu_cnt(c3)),var(sr_cnt(c3)),var(sl_cnt(c3)),var(su_cnt(c3)),var(sd_cnt(c3))];
% var_but_cnt(4,:) = [var(bd_cnt(c4)),var(bu_cnt(c4)),var(sr_cnt(c4)),var(sl_cnt(c4)),var(su_cnt(c4)),var(sd_cnt(c4))];
% var_but_cnt(5,:) = [var(bd_cnt(c5)),var(bu_cnt(c5)),var(sr_cnt(c5)),var(sl_cnt(c5)),var(su_cnt(c5)),var(sd_cnt(c5))];

raw = data;
x = data(:,50)-130;
y = data(:,51)-140;
z = data(:,52)-130;
accel_cal = [data(:,1:49),x,y,z];
accel_only = [data(:,1),x,y,z];
but_only = [accel_cal(:,1:49)];
but_group = [data(:,1),bd_cnt,bu_cnt,sr_cnt,sl_cnt,su_cnt,sd_cnt,x,y,z];

rat_group = but_group;
for i=1:N
    if rat_group(i,9) < 0   % Y < 0  flip up and down
        rat_group(i,:) = [rat_group(i,1),bu_cnt(i),bd_cnt(i),rat_group(i,4:5),sd_cnt(i),su_cnt(i),rat_group(i,8),abs(y(i)),rat_group(i,10)];
    end
    if rat_group(i,8) < 0
        rat_group(i,:) = [rat_group(i,1:3),sl_cnt(i),sr_cnt(i),rat_group(i,6:7),abs(x(i)),rat_group(i,9:10)];
    end
end

% diagnostics for buttons
% avg_but_cnt2 = zeros(5,6);
% avg_but_cnt2(1,:) = [mean(rat_group(c1,1)),mean(rat_group(c1,2)),mean(rat_group(c1,3)),mean(rat_group(c1,4)),mean(rat_group(c1,5)),mean(rat_group(c1,6))];
% avg_but_cnt2(2,:) = [mean(rat_group(c2,1)),mean(rat_group(c2,2)),mean(rat_group(c2,3)),mean(rat_group(c2,4)),mean(rat_group(c2,5)),mean(rat_group(c2,6))];
% avg_but_cnt2(3,:) = [mean(rat_group(c3,1)),mean(rat_group(c3,2)),mean(rat_group(c3,3)),mean(rat_group(c3,4)),mean(rat_group(c3,5)),mean(rat_group(c3,6))];
% avg_but_cnt2(4,:) = [mean(rat_group(c4,1)),mean(rat_group(c4,2)),mean(rat_group(c4,3)),mean(rat_group(c4,4)),mean(rat_group(c4,5)),mean(rat_group(c4,6))];
% avg_but_cnt2(5,:) = [mean(rat_group(c5,1)),mean(rat_group(c5,2)),mean(rat_group(c5,3)),mean(rat_group(c5,4)),mean(rat_group(c5,5)),mean(rat_group(c5,6))];
% var_but_cnt2 = zeros(5,6);
% var_but_cnt2(1,:) = [var(rat_group(c1,1)),var(rat_group(c1,2)),var(rat_group(c1,3)),var(rat_group(c1,4)),var(rat_group(c1,5)),var(rat_group(c1,6))];
% var_but_cnt2(2,:) = [var(rat_group(c2,1)),var(rat_group(c2,2)),var(rat_group(c2,3)),var(rat_group(c2,4)),var(rat_group(c2,5)),var(rat_group(c2,6))];
% var_but_cnt2(3,:) = [var(rat_group(c3,1)),var(rat_group(c3,2)),var(rat_group(c3,3)),var(rat_group(c3,4)),var(rat_group(c3,5)),var(rat_group(c3,6))];
% var_but_cnt2(4,:) = [var(rat_group(c4,1)),var(rat_group(c4,2)),var(rat_group(c4,3)),var(rat_group(c4,4)),var(rat_group(c4,5)),var(rat_group(c4,6))];
% var_but_cnt2(5,:) = [var(rat_group(c5,1)),var(rat_group(c5,2)),var(rat_group(c5,3)),var(rat_group(c5,4)),var(rat_group(c5,5)),var(rat_group(c5,6))];

% mu = mean(raw(:,2:52));
% Sw = (raw(:,2:52) - ones(N,1)*mu)'*(raw(:,2:52) - ones(N,1)*mu);
% mu1 = mean(raw(c1,2:52));
% mu2 = mean(raw(c2,2:52));
% mu3 = mean(raw(c3,2:52));
% mu4 = mean(raw(c4,2:52));
% mu5 = mean(raw(c5,2:52));
% Sb = (N/5)*((mu1-mu)'*(mu1-mu) + (mu2-mu)'*(mu2-mu) + (mu3-mu)'*(mu3-mu) + (mu4-mu)'*(mu4-mu) + (mu5-mu)'*(mu5-mu));
% [fv fd] = eig(Sb,Sw);
% [cc i1] = max(max(fd))
% fd(i1,:) = 0;
% [cc i2] = max(max(fd))
% fd(i2,:) = 0;
% [cc i3] = max(max(fd))
% fd(i3,:) = 0;
% [cc i4] = max(max(fd))
% fi = [i1,i2,i3,i4];
% fW = fv(:,fi);
% fisher = [raw(:,1),(fW'*raw(:,2:52)')'];
% 
% [pv pd] = eig(Sw);
% pW = pv(:,1:4);
% pca = [raw(:,1),(pW'*raw(:,2:52)')'];

switch type
    case 1
        data_out = accel_cal;
    case 2
        data_out = accel_only;
    case 3
        data_out = but_group;
    case 4
        data_out = but_only;
    case 5 
        data_out = rat_group;
    case 6
        r = rat_group;
        data_out = [r(:,1),r(:,2:3)/12,r(:,4:5)/7,r(:,6:7)/5,r(:,8:9)/70,(r(:,10)+70)/140];
    otherwise
        data_out = 0;
end

